Index: stable/HeuristicLab.Algorithms.RAPGA/3.3/RAPGA.cs
===================================================================
--- stable/HeuristicLab.Algorithms.RAPGA/3.3/RAPGA.cs	(revision 14139)
+++ stable/HeuristicLab.Algorithms.RAPGA/3.3/RAPGA.cs	(revision 14141)
@@ -205,6 +205,6 @@
         Parameters.Add(new FixedValueParameter<BoolValue>("ReevaluateElites", "Flag to determine if elite individuals should be reevaluated (i.e., if stochastic fitness functions are used.)", (BoolValue)new BoolValue(false).AsReadOnly()) { Hidden = true });
       }
+#pragma warning disable 0618
       if (Parameters.ContainsKey("SimilarityCalculator") && Parameters["SimilarityCalculator"] is IConstrainedValueParameter<ISingleObjectiveSolutionSimilarityCalculator>) {
-#pragma warning disable 0618
         var oldParameter = (IConstrainedValueParameter<ISingleObjectiveSolutionSimilarityCalculator>)Parameters["SimilarityCalculator"];
 #pragma warning restore 0618
Index: stable/HeuristicLab.Algorithms.ScatterSearch/3.3/ScatterSearch.cs
===================================================================
--- stable/HeuristicLab.Algorithms.ScatterSearch/3.3/ScatterSearch.cs	(revision 14139)
+++ stable/HeuristicLab.Algorithms.ScatterSearch/3.3/ScatterSearch.cs	(revision 14141)
@@ -162,6 +162,6 @@
       // BackwardsCompatibility3.3
       #region Backwards compatible code, remove with 3.4
+#pragma warning disable 0618
       if (Parameters.ContainsKey("SimilarityCalculator") && Parameters["SimilarityCalculator"] is IConstrainedValueParameter<ISingleObjectiveSolutionSimilarityCalculator>) {
-#pragma warning disable 0618
         var oldParameter = (IConstrainedValueParameter<ISingleObjectiveSolutionSimilarityCalculator>)Parameters["SimilarityCalculator"];
 #pragma warning restore 0618
Index: stable/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.cs
===================================================================
--- stable/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.cs	(revision 14139)
+++ stable/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.cs	(revision 14141)
@@ -537,5 +537,5 @@
     }
 
-    private void dataGridView_KeyDown(object sender, KeyEventArgs e) {
+    protected override void dataGridView_KeyDown(object sender, KeyEventArgs e) {
       var selectedRows = dataGridView.SelectedRows;
       var selectedCells = dataGridView.SelectedCells;
Index: stable/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/ConstantModel.cs
===================================================================
--- stable/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/ConstantModel.cs	(revision 14139)
+++ stable/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/ConstantModel.cs	(revision 14141)
@@ -97,5 +97,7 @@
     }
 
+#pragma warning disable 0067
     public event EventHandler ValueChanged;
+#pragma warning restore 0067
     #endregion
 
Index: stable/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/ConstantRegressionModel.cs
===================================================================
--- stable/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/ConstantRegressionModel.cs	(revision 14139)
+++ stable/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/ConstantRegressionModel.cs	(revision 14141)
@@ -85,5 +85,7 @@
     }
 
+#pragma warning disable 0067
     public event EventHandler ValueChanged;
+#pragma warning restore 0067
     #endregion
   }
Index: stable/HeuristicLab.Problems.PTSP/3.3/Moves/TwoPointFiveOpt/TwoPointFiveMove.cs
===================================================================
--- stable/HeuristicLab.Problems.PTSP/3.3/Moves/TwoPointFiveOpt/TwoPointFiveMove.cs	(revision 14139)
+++ stable/HeuristicLab.Problems.PTSP/3.3/Moves/TwoPointFiveOpt/TwoPointFiveMove.cs	(revision 14141)
@@ -30,11 +30,11 @@
   public sealed class TwoPointFiveMove : Item {
     [Storable]
-    public int Index1 { get; protected set; }
+    public int Index1 { get; private set; }
     [Storable]
-    public int Index2 { get; protected set; }
+    public int Index2 { get; private set; }
     [Storable]
-    public Permutation Permutation { get; protected set; }
+    public Permutation Permutation { get; private set; }
     [Storable]
-    public bool IsInvert { get; protected set; }
+    public bool IsInvert { get; private set; }
 
     [StorableConstructor]
Index: stable/HeuristicLab.Problems.QuadraticAssignment/3.3/Analyzers/QAPPopulationDiversityAnalyzer.cs
===================================================================
--- stable/HeuristicLab.Problems.QuadraticAssignment/3.3/Analyzers/QAPPopulationDiversityAnalyzer.cs	(revision 14139)
+++ stable/HeuristicLab.Problems.QuadraticAssignment/3.3/Analyzers/QAPPopulationDiversityAnalyzer.cs	(revision 14141)
@@ -34,5 +34,7 @@
   [Item("QAPPopulationDiversityAnalyzer", "An operator for analyzing the diversity of solutions of Quadratic Assignment Problems regarding their structural identity (number of equal facilty->location assignments).")]
   [StorableClass]
+#pragma warning disable 0612
   public sealed class QAPPopulationDiversityAnalyzer : PopulationDiversityAnalyzer<Permutation> {
+#pragma warning restore 0612
     public IValueParameter<BoolValue> UsePhenotypeSimilarityParameter {
       get { return (IValueParameter<BoolValue>)Parameters["UsePhenotypeSimilarity"]; }