Index: /trunk/sources/HeuristicLab 3.3 Hive.Slave.sln
===================================================================
--- /trunk/sources/HeuristicLab 3.3 Hive.Slave.sln	(revision 14163)
+++ /trunk/sources/HeuristicLab 3.3 Hive.Slave.sln	(revision 14164)
@@ -1,7 +1,5 @@
 ﻿
 Microsoft Visual Studio Solution File, Format Version 12.00
-# Visual Studio 14
-VisualStudioVersion = 14.0.23107.0
-MinimumVisualStudioVersion = 10.0.40219.1
+# Visual Studio 2012
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.Hive.Slave-3.3", "HeuristicLab.Clients.Hive.Slave\3.3\HeuristicLab.Clients.Hive.Slave-3.3.csproj", "{989FE92B-484E-41EE-87E2-6A24AF0381D8}"
 EndProject
@@ -26,76 +24,76 @@
 	EndGlobalSection
 	GlobalSection(ProjectConfigurationPlatforms) = postSolution
-		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Debug|Any CPU.ActiveCfg = Release|Any CPU
-		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Debug|Any CPU.Build.0 = Release|Any CPU
-		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Debug|x64.ActiveCfg = Release|Any CPU
-		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Debug|x64.Build.0 = Release|Any CPU
-		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Debug|x86.ActiveCfg = Release|Any CPU
-		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Debug|x86.Build.0 = Release|Any CPU
+		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Debug|x64.ActiveCfg = Debug|x64
+		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Debug|x64.Build.0 = Debug|x64
+		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Debug|x86.ActiveCfg = Debug|x86
+		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Debug|x86.Build.0 = Debug|x86
 		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Release|Any CPU.Build.0 = Release|Any CPU
-		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Release|x64.ActiveCfg = Release|Any CPU
-		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Release|x64.Build.0 = Release|Any CPU
-		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Release|x86.ActiveCfg = Release|Any CPU
-		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Release|x86.Build.0 = Release|Any CPU
-		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Debug|Any CPU.ActiveCfg = Release|Any CPU
-		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Debug|Any CPU.Build.0 = Release|Any CPU
-		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Debug|x64.ActiveCfg = Release|Any CPU
-		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Debug|x64.Build.0 = Release|Any CPU
-		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Debug|x86.ActiveCfg = Release|Any CPU
-		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Debug|x86.Build.0 = Release|Any CPU
+		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Release|x64.ActiveCfg = Release|x64
+		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Release|x64.Build.0 = Release|x64
+		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Release|x86.ActiveCfg = Release|x86
+		{989FE92B-484E-41EE-87E2-6A24AF0381D8}.Release|x86.Build.0 = Release|x86
+		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Debug|x64.ActiveCfg = Debug|x64
+		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Debug|x64.Build.0 = Debug|x64
+		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Debug|x86.ActiveCfg = Debug|x86
+		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Debug|x86.Build.0 = Debug|x86
 		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Release|Any CPU.Build.0 = Release|Any CPU
-		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Release|x64.ActiveCfg = Release|Any CPU
-		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Release|x64.Build.0 = Release|Any CPU
-		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Release|x86.ActiveCfg = Release|Any CPU
-		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Release|x86.Build.0 = Release|Any CPU
-		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Debug|Any CPU.ActiveCfg = Release|Any CPU
-		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Debug|Any CPU.Build.0 = Release|Any CPU
-		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Debug|x64.ActiveCfg = Release|Any CPU
-		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Debug|x64.Build.0 = Release|Any CPU
-		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Debug|x86.ActiveCfg = Release|Any CPU
-		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Debug|x86.Build.0 = Release|Any CPU
+		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Release|x64.ActiveCfg = Release|x64
+		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Release|x64.Build.0 = Release|x64
+		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Release|x86.ActiveCfg = Release|x86
+		{8C0D9F39-397F-4DBE-856F-BC4DC0FE23F8}.Release|x86.Build.0 = Release|x86
+		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Debug|x64.ActiveCfg = Debug|x64
+		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Debug|x64.Build.0 = Debug|x64
+		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Debug|x86.ActiveCfg = Debug|x86
+		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Debug|x86.Build.0 = Debug|x86
 		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Release|Any CPU.Build.0 = Release|Any CPU
-		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Release|x64.ActiveCfg = Release|Any CPU
-		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Release|x64.Build.0 = Release|Any CPU
-		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Release|x86.ActiveCfg = Release|Any CPU
-		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Release|x86.Build.0 = Release|Any CPU
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|Any CPU.ActiveCfg = Release|Any CPU
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|Any CPU.Build.0 = Release|Any CPU
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|x64.ActiveCfg = Release|Any CPU
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|x64.Build.0 = Release|Any CPU
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|x86.ActiveCfg = Release|Any CPU
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|x86.Build.0 = Release|Any CPU
+		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Release|x64.ActiveCfg = Release|x64
+		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Release|x64.Build.0 = Release|x64
+		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Release|x86.ActiveCfg = Release|x86
+		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Release|x86.Build.0 = Release|x86
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|x64.ActiveCfg = Debug|x64
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|x64.Build.0 = Debug|x64
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|x86.ActiveCfg = Debug|x86
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|x86.Build.0 = Debug|x86
 		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|Any CPU.Build.0 = Release|Any CPU
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|x64.ActiveCfg = Release|Any CPU
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|x64.Build.0 = Release|Any CPU
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|x86.ActiveCfg = Release|Any CPU
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|x86.Build.0 = Release|Any CPU
-		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Debug|Any CPU.ActiveCfg = Release|Any CPU
-		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Debug|Any CPU.Build.0 = Release|Any CPU
-		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Debug|x64.ActiveCfg = Release|Any CPU
-		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Debug|x64.Build.0 = Release|Any CPU
-		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Debug|x86.ActiveCfg = Release|Any CPU
-		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Debug|x86.Build.0 = Release|Any CPU
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|x64.ActiveCfg = Release|x64
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|x64.Build.0 = Release|x64
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|x86.ActiveCfg = Release|x86
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|x86.Build.0 = Release|x86
+		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Debug|x64.ActiveCfg = Debug|x64
+		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Debug|x64.Build.0 = Debug|x64
+		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Debug|x86.ActiveCfg = Debug|x86
+		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Debug|x86.Build.0 = Debug|x86
 		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Release|Any CPU.Build.0 = Release|Any CPU
-		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Release|x64.ActiveCfg = Release|Any CPU
-		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Release|x64.Build.0 = Release|Any CPU
-		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Release|x86.ActiveCfg = Release|Any CPU
-		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Release|x86.Build.0 = Release|Any CPU
-		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Debug|Any CPU.ActiveCfg = Release|Any CPU
-		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Debug|Any CPU.Build.0 = Release|Any CPU
-		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Debug|x64.ActiveCfg = Release|Any CPU
-		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Debug|x64.Build.0 = Release|Any CPU
-		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Debug|x86.ActiveCfg = Release|Any CPU
-		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Debug|x86.Build.0 = Release|Any CPU
+		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Release|x64.ActiveCfg = Release|x64
+		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Release|x64.Build.0 = Release|x64
+		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Release|x86.ActiveCfg = Release|x86
+		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Release|x86.Build.0 = Release|x86
+		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Debug|x64.ActiveCfg = Debug|x64
+		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Debug|x64.Build.0 = Debug|x64
+		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Debug|x86.ActiveCfg = Debug|x86
+		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Debug|x86.Build.0 = Debug|x86
 		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Release|Any CPU.Build.0 = Release|Any CPU
-		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Release|x64.ActiveCfg = Release|Any CPU
-		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Release|x64.Build.0 = Release|Any CPU
-		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Release|x86.ActiveCfg = Release|Any CPU
-		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Release|x86.Build.0 = Release|Any CPU
+		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Release|x64.ActiveCfg = Release|x64
+		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Release|x64.Build.0 = Release|x64
+		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Release|x86.ActiveCfg = Release|x86
+		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Release|x86.Build.0 = Release|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.Designer.cs	(revision 14163)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.Designer.cs	(revision 14164)
@@ -1,9 +1,9 @@
 ﻿//------------------------------------------------------------------------------
 // <auto-generated>
-//     This code was generated by a tool.
-//     Runtime Version:4.0.30319.42000
+//     Dieser Code wurde von einem Tool generiert.
+//     Laufzeitversion:4.0.30319.42000
 //
-//     Changes to this file may cause incorrect behavior and will be lost if
-//     the code is regenerated.
+//     Änderungen an dieser Datei können falsches Verhalten verursachen und gehen verloren, wenn
+//     der Code erneut generiert wird.
 // </auto-generated>
 //------------------------------------------------------------------------------
@@ -266,5 +266,5 @@
         [global::System.Configuration.UserScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("4")]
+        [global::System.Configuration.DefaultSettingValueAttribute("-1")]
         public int NrOfCoresToScavenge {
             get {
Index: /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.settings
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.settings	(revision 14163)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.settings	(revision 14164)
@@ -64,5 +64,5 @@
     </Setting>
     <Setting Name="NrOfCoresToScavenge" Type="System.Int32" Scope="User">
-      <Value Profile="(Default)">4</Value>
+      <Value Profile="(Default)">-1</Value>
     </Setting>
     <Setting Name="ShutdownCommand" Type="System.String" Scope="User">